
namespace adv

--include alt_eu4.e -- alt_eu4.e: for information use only.

public include normal.e as normal
--  in normal.e:
-- sequence data
-- integer id
-- public type normal_t(object name)
-- public function size()
-- public function new(object n = {})
-- public function select(integer i)
-- public function get()
-- public function set(object val)
-- public function id_dump()
-- public function id_replace(integer i)
-- public function data_dump()
-- public function data_replace(sequence d)

--  in advanced.e:
-- public function binary_search(object needle, sequence haystack, integer start_point = 1, integer end_point = 0)
-- sequence names -- sequence of names
-- sequence ids -- sequence of actual ids, linked with names
-- sequence unnamed
-- public type advanced_t(object name)
-- public function search_for_name(object name)
-- public function new(object d = {}, object name = {})

-- public function get_id_from_name(object name)
-- public function get_name_from_id(integer i)

-- public function unnamed_dump()
-- public function ids_dump()
-- public function names_dump()


--taked from std/search.e to avoid including.
public function binary_search(object needle, sequence haystack, integer start_point = 1, integer end_point = 0)
	integer lo, hi, mid, c  -- works up to 1.07 billion records
	
	lo = start_point
	if end_point <= 0 then
		hi = length(haystack) + end_point
	else
		hi = end_point
	end if
	if lo<1 then
		lo=1
	end if
	if lo > hi and length(haystack) > 0 then
		hi = length(haystack)
	end if
	mid = start_point
	c = 0
	while lo <= hi do
		mid = floor((lo + hi) / 2)
		c = eu:compare(needle, haystack[mid])
		if c < 0 then
			hi = mid - 1
		elsif c > 0 then
			lo = mid + 1
		else
			return mid
		end if
	end while
	-- return the position it would have, if inserted now
	if c > 0 then
		mid += 1
	end if
	return -mid
end function

-- Local variables:

-- ( added on to inherited variables and functions )

-- names associatd with ids:

sequence names -- sequence of names
sequence ids -- sequence of actual ids, linked with names
sequence unnamed
-- object current_name -- id's name (must be unique, or else behavior is undefined)
-- sequence data -- in normal.e
-- sequence id -- in normal.e

-- initialize:

-- current_name = "" -- can be any object (including a string)

-- these all have the same length (including "data"), so you can use "size()" to get length.
names = {} -- a list of names
ids = {} -- list of id's
unnamed = {}


-- Public methods:

public type advanced_t(object name)
	return 1
end type

public function search_for_name(object name)
	return binary_search( name, names )
end function

public function new(object d = {}, object name = {})
	integer i, p
	if sequence( name ) and length( name ) = 0 then
		p = normal:new( d )
		unnamed = faster_append( unnamed, p )
		return p
	end if
	i = - search_for_name( name ) -- negate returned value
	if i < 0 then
		return i -- already exists, return negative value
	end if
	-- does not exist, create new one
	p = normal:new( d )
	names = insert( names, name, i )
	ids = insert( ids, p, i )
	return p
end function

public function get_id_from_name(object name)
	integer i
	i = binary_search( name, names )
	if i > 0 then
		return ids[i]
	else
		return i
	end if
end function

public function get_name_from_id(integer i)
	i = binary_search( i, ids )
	if i > 0 then
		return names[i]
	else
		return i
	end if
end function




public function unnamed_dump()
	return unnamed
end function
public function ids_dump()
	return ids
end function
public function names_dump()
	return names
end function

public function dump_all()
	return normal:dump_all() & {unnamed_dump()} & {ids_dump()} & {names_dump()}
end function

