
namespace eu4

without warning

override function remove(sequence target, atom start, atom stop=start) -- optimized --
	-- if "stop" is omitted, pass "start" as both "start" and "stop"
	return target[1..start-1] & target[stop+1..$]
end function

override function replace(sequence target, object replacement, integer start, integer stop=start) -- optimized --
	-- if "stop" is omitted, pass "start" as both "start" and "stop"
	return target[1..start-1] & replacement & target[stop+1..$]
end function

override function head(sequence source, atom size=1) -- optimized --
	-- if "size" is omitted, pass 1 as "size"
	return source[1..size]
end function

override function tail(sequence source, atom size=length(source) - 1) -- optimized --
	-- if "size" is omitted, pass ( length( source ) - 1 ) as "size"
	return source[$-size+1..$]
end function

override function splice(sequence target, object what, integer index) -- optimized --
	return target[1..index-1] & what & target[index..$]
end function

override function insert(sequence target, object what, integer index) -- optimized --
	return target[1..index-1] & {what} & target[index..$]
end function
